{	This program is copyright (c) 1993 - 2005 Jos Kunst, the Jos Kunst heirs.	}
{	This program is free software. You can redistribute it and/or modify it 	}
{	under the terms of version 2 of the GNU General Public License, which you	}
{	should have received with it.												}
{	This program is distributed in the hope that it will be useful, but			}
{	without any warranty, expressed or implied.									}

program chordfingerings (output);
	uses
		translations;
	type
		instruments = (vln, vla, vlc, cb);
	const
		number = 8;

	var
		ins: instruments;
		target: pitchset;
		printfile, alldone: boolean;
		ch: char;
		fullscreen: rect;
		fingeringfile: text;

	procedure decidewhethertoprint;
		var
			c: char;
			filename: string[128];
	begin
		write('Do you want results stored in printable diskfile? (Y/N)-->');
		readln(c);
		if upcased(c) <> 'N' then
			begin
				filename := '';
				filename := NewFileName('Name your file.', 'FSCfile');
				if filename <> '' then
					begin
						printfile := TRUE;
						open(fingeringfile, filename);
						rewrite(fingeringfile)
					end
			end
	end;


	procedure specifytask (var t: pitchset; var i: instruments);
		var
			s: chordstring;
			c: char;
			strqtet: set of char;
			p: byte;
	begin
		write('Chord to be given a fingering ');
		writeln('(each note to be ended by its');
		write('octave digit: a440 = a4)-->');
		readln(s);
		makeintoset(s, t);
		if printfile then
			begin
				writeln(fingeringfile);
				write(fingeringfile, 'Chord: ');
				for p := bottomnote to topnote do
					if p in t then
						write(fingeringfile, nameof(p), ' ')
			end;
		strqtet := ['1', '2', '3'];
		repeat
			write('Instrument the fingering is for: ');
			writeln('1: violin; 2: viola; 3: violoncello');
			write('(1/2/3)-->');
			readln(c)
		until c in strqtet;
		case c of
			'1': 
				begin
					i := vln;
					if printfile then
						writeln(fingeringfile, 'for violin;')
				end;
			'2': 
				begin
					i := vla;
					if printfile then
						writeln(fingeringfile, 'for viola;')
				end;
			'3': 
				begin
					i := vlc;
					if printfile then
						writeln(fingeringfile, 'for violoncello;')
				end
		end
	end;

	procedure givefingeringsfor (strinstrnt: instruments);
		type
			lefthand = array[1..4] of byte;
			alefthand = array[1..5] of integer;
			resultlist = array[1..number] of alefthand;
		var
			halfposition, f1, f2, f3, f4, i, ii, j, ij, str, incr2, incr3, incr4, s, a, b, counter: byte;
			alerts: integer;
			pset, dozeroson, exceptstrings, fiftheds, tuningset: pitchset;
			tuning: array[1..4] of byte;
			fingering: lefthand; { de vier snaren; ze krijgen positiegetallen toegewezen }
			inventory: resultlist;
			dofifths, taskdone, nolefthand: boolean;

		procedure giveprelposfor (cs: pitchset; var ps: pitchset);
			var
				tar: set of byte;
				p, pp, q, pos, posit, str, strings, sstrings: byte;
				chord, cord: array[1..4] of byte;
				prelfin: lefthand;
				testpositive: boolean;
				compexceptstrings: pitchset;

			procedure closegap (var pr: lefthand);
				var
					str, sstr: byte;
					somenote, somegap: boolean;
			begin
				str := 5;
				somenote := FALSE;
				repeat
					str := str - 1;
					if pr[str] < 99 then
						somenote := TRUE
				until somenote or (str = 1);
				if somenote then
					begin
						repeat
							str := str - 1;
							if pr[str] = 99 then
								begin
									somegap := FALSE;
									sstr := str;
									repeat
										sstr := sstr - 1;
										if sstr > 0 then
											if pr[sstr] < 99 then
												somegap := TRUE
									until (sstr <= 1) or somegap;
									if somegap then
										begin
											pr[str] := pr[sstr] + (str - sstr) * 7;
											pr[sstr] := 99
										end
								end
						until str <= 2
					end
			end;
{---------------vul array chord met accoord--------------}
		begin
			for p := 1 to 4 do
				chord[p] := 0;
			tar := cs;
			ps := [];
			for p := topnote downto bottomnote do
				if p in tar then
					begin
						if chord[1] = 0 then
							begin
								chord[1] := p;
								tar := tar - [p]
							end;
						if (chord[2] = 0) and (p < chord[1]) then
							begin
								chord[2] := p;
								tar := tar - [p]
							end;
						if (chord[3] = 0) and (p < chord[2]) then
							begin
								chord[3] := p;
								tar := tar - [p]
							end;
						if (chord[4] = 0) and (p < chord[3]) then
							begin
								chord[4] := p;
								tar := tar - [p]
							end
					end;
			if tar <> [] then
				begin
					write('too many notes! ');
					if printfile then
						write(fingeringfile, 'too many notes!');
					exit(giveprelposfor)
				end;
{-------------houd geen rekening met mogelijkheid van open snaren---------}
			testpositive := TRUE;
			for strings := 1 to 4 do
				prelfin[strings] := 99;
			for p := 1 to 4 do
				if (chord[p] >= tuning[1]) and (prelfin[1] = 99) then
					prelfin[1] := chord[p] - tuning[1]
				else if (chord[p] >= tuning[2]) and (prelfin[2] = 99) then
					prelfin[2] := chord[p] - tuning[2]
				else if (chord[p] >= tuning[3]) and (prelfin[3] = 99) then
					prelfin[3] := chord[p] - tuning[3]
				else if (chord[p] >= tuning[4]) and (prelfin[4] = 99) then
					prelfin[4] := chord[p] - tuning[4]
				else if chord[p] > 0 then
					testpositive := FALSE;
			closegap(prelfin);
			write('testing for ');
			if printfile then
				write(fingeringfile, 'testing for ');
			for strings := 4 downto 1 do
				begin
					write(prelfin[strings] : 2, '  ');
					if printfile then
						write(fingeringfile, prelfin[strings] : 2, '  ')
				end;
			writeln;
			if printfile then
				writeln(fingeringfile);
			posit := 0;
			if testpositive then
				for pos := 17 downto 1 do
					for strings := 1 to 4 do
						if (prelfin[strings] > 0) and (pos = prelfin[strings]) then
							posit := pos;
			ps := [posit];
			exceptstrings := [];
			for strings := 1 to 4 do
				if prelfin[strings] = 99 then
					exceptstrings := exceptstrings + [strings];
{--------wijs waar mogelijk telkens een toon toe aan een open snaar-------}
			for p := 1 to 4 do
				for strings := 1 to 4 do
					if chord[p] = tuning[strings] then
						begin
							testpositive := TRUE;
							for str := 1 to 4 do
								prelfin[str] := 99;
							cord := chord;
							prelfin[strings] := 0;
							cord[p] := 0;
							for q := 1 to 4 do
								if cord[q] > 0 then
									if (cord[q] >= tuning[1]) and (prelfin[1] = 99) then
										prelfin[1] := cord[q] - tuning[1]
									else if (cord[q] >= tuning[2]) and (prelfin[2] = 99) then
										prelfin[2] := cord[q] - tuning[2]
									else if (cord[q] >= tuning[3]) and (prelfin[3] = 99) then
										prelfin[3] := cord[q] - tuning[3]
									else if (cord[q] >= tuning[4]) and (prelfin[4] = 99) then
										prelfin[4] := cord[q] - tuning[4]
									else if cord[q] > 0 then
										testpositive := FALSE;
							closegap(prelfin);
							write('testing for ');
							if printfile then
								write(fingeringfile, 'testing for ');
							for str := 4 downto 1 do
								begin
									write(prelfin[str] : 2, '  ');
									if printfile then
										write(fingeringfile, prelfin[str] : 2, '  ')
								end;
							writeln;
							if printfile then
								writeln(fingeringfile);
							posit := 0;
							if testpositive then
								for pos := 17 downto 1 do
									for str := 1 to 4 do
										if (prelfin[str] > 0) and (pos = prelfin[str]) then
											posit := pos;
							ps := ps + [posit];
							compexceptstrings := [];
							for str := 1 to 4 do
								if prelfin[str] = 99 then
									compexceptstrings := compexceptstrings + [str];
							exceptstrings := exceptstrings * compexceptstrings
						end;
{--------wijs waar mogelijk telkens twee tonen toe aan open snaren-------}
			for p := 1 to 3 do
				for pp := p + 1 to 4 do
					for strings := 1 to 3 do
						for sstrings := strings + 1 to 4 do
							if (chord[p] = tuning[strings]) and (chord[pp] = tuning[sstrings]) then
								begin
									testpositive := TRUE;
									for str := 1 to 4 do
										prelfin[str] := 99;
									cord := chord;
									prelfin[strings] := 0;
									prelfin[sstrings] := 0;
									cord[p] := 0;
									cord[pp] := 0;
									for q := 1 to 4 do
										if cord[q] > 0 then
											if (cord[q] >= tuning[1]) and (prelfin[1] = 99) then
												prelfin[1] := cord[q] - tuning[1]
											else if (cord[q] >= tuning[2]) and (prelfin[2] = 99) then
												prelfin[2] := cord[q] - tuning[2]
											else if (cord[q] >= tuning[3]) and (prelfin[3] = 99) then
												prelfin[3] := cord[q] - tuning[3]
											else if (cord[q] >= tuning[4]) and (prelfin[4] = 99) then
												prelfin[4] := cord[q] - tuning[4]
											else if cord[q] > 0 then
												testpositive := FALSE;
									closegap(prelfin);
									write('testing for ');
									if printfile then
										write(fingeringfile, 'testing for ');
									for str := 4 downto 1 do
										begin
											write(prelfin[str] : 2, '  ');
											if printfile then
												write(fingeringfile, prelfin[str] : 2, '  ')
										end;
									writeln;
									if printfile then
										writeln(fingeringfile);
									posit := 0;
									if testpositive then
										for pos := 17 downto 1 do
											for str := 1 to 4 do
												if (prelfin[str] > 0) and (pos = prelfin[str]) then
													posit := pos;
									ps := ps + [posit];
									compexceptstrings := [];
									for str := 1 to 4 do
										if prelfin[str] = 99 then
											compexceptstrings := compexceptstrings + [str];
									exceptstrings := exceptstrings * compexceptstrings
								end;
{--------wijs zo veel mogelijk tonen aan open snaren toe------------}
			testpositive := TRUE;
			for strings := 1 to 4 do
				prelfin[strings] := 99;
			cord := chord;
			for p := 1 to 4 do
				for strings := 1 to 4 do
					if cord[p] = tuning[strings] then
						begin
							prelfin[strings] := 0;
							cord[p] := 0
						end;
			for p := 1 to 4 do
				if cord[p] > 0 then
					if (cord[p] >= tuning[1]) and (prelfin[1] = 99) then
						prelfin[1] := cord[p] - tuning[1]
					else if (cord[p] >= tuning[2]) and (prelfin[2] = 99) then
						prelfin[2] := cord[p] - tuning[2]
					else if (cord[p] >= tuning[3]) and (prelfin[3] = 99) then
						prelfin[3] := cord[p] - tuning[3]
					else if (cord[p] >= tuning[4]) and (prelfin[4] = 99) then
						prelfin[4] := cord[p] - tuning[4]
					else if cord[p] > 0 then
						testpositive := FALSE;
			closegap(prelfin);
			write('testing for ');
			if printfile then
				write(fingeringfile, 'testing for ');
			for strings := 4 downto 1 do
				begin
					write(prelfin[strings] : 2, '  ');
					if printfile then
						write(fingeringfile, prelfin[strings] : 2, '  ')
				end;
			writeln;
			if printfile then
				writeln(fingeringfile);
			posit := 0;
			if testpositive then
				for pos := 17 downto 1 do
					for strings := 1 to 4 do
						if (prelfin[strings] > 0) and (pos = prelfin[strings]) then
							posit := pos;
			ps := ps + [posit];
			compexceptstrings := [];
			for str := 1 to 4 do
				if prelfin[str] = 99 then
					compexceptstrings := compexceptstrings + [str];
			exceptstrings := exceptstrings * compexceptstrings;
			write('testing halfposition(s) ');
			if printfile then
				write(fingeringfile, 'testing halfposition(s) ');
			for p := 1 to 17 do
				if p in ps then
					begin
						write(p : 2, '; ');
						if printfile then
							write(fingeringfile, p : 2, '; ')
					end;
{-----controleer op kwinten-----------}
			dofifths := FALSE;
			q := 0;
			for p := bottomnote to topnote do
				if p in target then
					begin
						if p - q = 7 then
							dofifths := TRUE;
						q := p
					end;
			if dofifths then
				begin
					write('fifths; ');
					if printfile then
						write(fingeringfile, 'fifths; ')
				end
			else
				begin
					write('no fifths; ');
					if printfile then
						write(fingeringfile, ' no fifths; ')
				end;
{------controleer op kansen voor open snaren--------}
			dozeroson := [];
			for str := 1 to 4 do
				if tuning[str] in target then
					dozeroson := dozeroson + [str];
			if dozeroson = [] then
				begin
					write('no open strings; ');
					if printfile then
						write(fingeringfile, 'no open strings; ')
				end
			else
				begin
					write('open strings; ');
					if printfile then
						write(fingeringfile, 'open strings; ')
				end
		end;

		procedure report (arr: lefthand);
			var
				str, c: byte;
				cs, eset: pitchset;
				arrempty, arrthere: boolean;
		begin{report}
			cs := [];
			for str := 1 to 4 do
				if not (arr[str] = 99) then
					cs := cs + [tuning[str] + arr[str]];
			if target <= cs then
				begin
					eset := [];
					for str := 1 to 4 do
						if (arr[str] = 99) or (arr[str] = 0) then
							eset := eset + [str];
					eset := eset + fiftheds;
					if strinstrnt = vlc then
						begin
{---------Q-position vs normal position--------------------}
							if (incr2 > 2) or ((incr3 <> 1) or (incr4 <> 1)) then
								begin
									if alerts mod 13 <> 0 then
										alerts := alerts * 13
								end
							else if alerts mod 2 <> 0 then
								alerts := alerts * 2;
{-----------------hindered open string--------------------}
							for str := 1 to 2 do
								if (arr[str] = 0) and (not (str + 1 in eset) and (arr[str + 1] = arr[str + 2])) then
									if (alerts mod 2 = 0) and (alerts mod 4 <> 0) then
										alerts := alerts * 2
						end;
					if (strinstrnt = vln) or (strinstrnt = vla) then
						begin
{-----two fingers in same halfposition-------------}
							if arr[1] = arr[3] then
								if not (1 in eset) then
									if alerts mod 3 <> 0 then
										alerts := alerts * 3;
							if arr[1] = arr[4] then
								if not (1 in eset) then
									if alerts mod 3 <> 0 then
										alerts := alerts * 3;
							if arr[2] = arr[4] then
								if not (2 in eset) then
									if alerts mod 3 <> 0 then
										alerts := alerts * 3;
{----------------twice stretched--------------------}
							if (incr2 = 3) and (incr3 = 3) then
								if not (((f1 in eset) or (f2 in eset)) or (f3 in eset)) then
									if alerts mod 5 <> 0 then
										alerts := alerts * 5;
							if (incr2 = 3) and (incr4 = 3) then
								if not (((f1 in eset) or (f2 in eset)) or ((f3 in eset) or (f4 in eset))) then
									if alerts mod 5 <> 0 then
										alerts := alerts * 5;
							if (incr3 = 3) and (incr4 = 3) then
								if not ((f2 in eset) or ((f3 in eset) or (f4 in eset))) then
									if alerts mod 5 <> 0 then
										alerts := alerts * 5;
{------------very wide stretching-------------------}
							if incr2 = 4 then
								if not ((f1 in eset) or (f2 in eset)) then
									if alerts mod 7 <> 0 then
										alerts := alerts * 7;
							if incr3 = 4 then
								if not ((f2 in eset) or (f3 in eset)) then
									if alerts mod 7 <> 0 then
										alerts := alerts * 7;
							if incr4 = 4 then
								if not ((f3 in eset) or (f4 in eset)) then
									if alerts mod 7 <> 0 then
										alerts := alerts * 7
						end;
					c := 0;
					repeat
						arrempty := TRUE;
						arrthere := TRUE;
						c := c + 1;
						for str := 1 to 4 do
							begin
								if inventory[c][str] <> arr[str] then
									arrthere := FALSE;
								if inventory[c][5] <> alerts then
									arrthere := FALSE;
								if inventory[c][str] <> 99 then
									arrempty := FALSE
							end
					until (c = number) or (arrempty or arrthere);
					if (c = number) and not arrempty then
						taskdone := TRUE;
					if (not arrthere) and arrempty then
						begin
							for str := 1 to 4 do
								inventory[c][str] := arr[str];
							write('f', c : 1);
							inventory[c][5] := alerts
						end
				end
		end;{report}

		procedure openstrings (arr: lefthand; doneon: pitchset);
			var
				str, sstr: byte;
				fingarr: lefthand;
		begin{openstrings}
			fingarr := arr;
			for str := 1 to 4 do
				if str in doneon then
					fingarr[str] := 0;
			report(fingarr);                          { all zeroed  }
			for str := 1 to 4 do
				if str in doneon then
					begin
						fingarr[str] := arr[str];
						report(fingarr);                        { just one not zeroed  }
						fingarr[str] := 0
					end;
			for str := 1 to 3 do
				if str in doneon then
					for sstr := str + 1 to 4 do
						if sstr in doneon then
							begin
								fingarr := arr;
								fingarr[str] := 0;
								fingarr[sstr] := 0;
								report(fingarr)                        { just two zeroed  }
							end;
			for str := 1 to 4 do
				if str in doneon then
					begin
						fingarr := arr;
						fingarr[str] := 0;
						report(fingarr)                        { just one zeroed }
					end;
		end;{openstrings}

		procedure lessfingers (arr: lefthand);
			var
				fingarray: lefthand;
				done: boolean;
				doiton: pitchset;
				str: byte;
		begin{lessfingers}
{------maak kwint(en), wijsvinger-----}
			if (strinstrnt = vln) or (strinstrnt = vla) then
				if halfposition < 8 then
					begin
						fingarray := arr;
						doiton := dozeroson;
						if f1 <> 4 then
							if ((f1 <> 1) or (fingarray[3] <> fingarray[1])) and ((f1 <> 2) or (fingarray[4] <> fingarray[2])) then
								if fingarray[f1 + 1] <> 99 then
									begin
										fingarray[f1 + 1] := fingarray[f1];
										fiftheds := [f1, f1 + 1];
										doiton := doiton - fiftheds;
										report(fingarray);
										openstrings(fingarray, doiton)
									end;
{------maak een kwint, middelvinger---------}
						fingarray := arr;
						doiton := dozeroson;
						if f2 <> 4 then
							if ((f2 <> 1) or (fingarray[3] <> fingarray[1])) and ((f2 <> 2) or (fingarray[4] <> fingarray[2])) then
								if fingarray[f2 + 1] <> 99 then
									begin
										fingarray[f2 + 1] := fingarray[f2];
										fiftheds := [f2, f2 + 1];
										doiton := doiton - fiftheds;
										report(fingarray);
										openstrings(fingarray, doiton)
									end;
{-----en dan de wijsvinger-kwint plus de middelvinger-kwint----}
						fingarray := arr;
						if (((f1 = 1) and (f2 = 3)) or ((f1 = 3) and (f2 = 1))) then
							if ((fingarray[f1 + 1] <> 99) and (fingarray[f2 + 1] <> 99)) then
								if fingarray[1] <> fingarray[3] then
									begin
										fingarray[f1 + 1] := fingarray[f1];
										fingarray[f2 + 1] := fingarray[f2];
										fiftheds := [1, 2, 3, 4];
										report(fingarray)
									end
					end;
{-------------------vlc: fifths for all fingers-------------------}
			if strinstrnt = vlc then
				begin
					for str := 1 to 3 do
						begin
							fingarray := arr;
							doiton := dozeroson;
							if (fingarray[str] <> 99) and (fingarray[str + 1] <> 99) then
								begin
									fingarray[str + 1] := fingarray[str];
									doiton := doiton - [str, str + 1];
									report(fingarray);
									openstrings(fingarray, doiton)
								end
						end;
{-------------------vlc: two fifths-------------------------------}
					fingarray := arr;
					if ((fingarray[1] <> 99) and (fingarray[2] <> 99)) and ((fingarray[3] <> 99) and (fingarray[4] <> 99)) then
						begin
							fingarray[2] := fingarray[1];
							fingarray[4] := fingarray[3];
							report(fingarray)
						end
				end
		end;{lessfingers}

		procedure barrechords (arr: lefthand);
			var
				str, sstr, ssstr: byte;
				fingarr: lefthand;
				doiton: pitchset;
		begin{barrechords}
			fingarr := arr;
			if f1 = 4 then
				doiton := []
			else
				doiton := dozeroson - [3, 2, 1];
			for str := 1 to f1 - 1 do
				if not (fingarr[str] = 99) then
					for sstr := 1 to f1 - 1 do
						if not (fingarr[sstr] = 99) then
							for ssstr := 1 to f1 - 1 do
								if not (fingarr[ssstr] = 99) then
									begin
										fingarr[str] := fingarr[f1];
										fingarr[sstr] := fingarr[f1];
										fingarr[ssstr] := fingarr[f1];
										if alerts mod 11 <> 0 then
											alerts := alerts * 11;
										report(fingarr);
										openstrings(fingarr, doiton);
										fingarr := arr
									end;
			if f2 = 3 then
				doiton := dozeroson - [3, 2, 1];
			for str := 1 to f2 - 1 do
				if not (fingarr[str] = 99) then
					for sstr := 1 to f2 - 1 do
						if not (fingarr[sstr] = 99) then
							begin
								fingarr[str] := fingarr[f2];
								fingarr[sstr] := fingarr[f2];
								if alerts mod 11 <> 0 then
									alerts := alerts * 11;
								report(fingarr);
								openstrings(fingarr, doiton);
								fingarr := arr
							end
		end;{barrechords}

		procedure writeresults (r: resultlist);
			var
				c, str: byte;
				arrempty: boolean;
		begin
			c := 1;
			repeat
				arrempty := TRUE;
				for str := 1 to 5 do
					if r[c][str] <> 99 then
						arrempty := FALSE;
				if (c = 1) and arrempty then
					begin
						writeln;
						if printfile then
							writeln(fingeringfile);
						write('no fingerings');
						if printfile then
							write(fingeringfile, 'no fingerings')
					end
				else if not arrempty then
					begin
						writeln;
						if printfile then
							writeln(fingeringfile);
						write('fingering ', c : 1, ': ');
						if printfile then
							write(fingeringfile, 'fingering ', c : 1, ': ');
						for str := 4 downto 1 do
							begin
								write(r[c][str] : 2, '  ');
								if printfile then
									write(fingeringfile, r[c][str] : 2, '  ')
							end;
						if r[c][5] = 0 then
							write('all open strings; ')
						else
							begin
								if r[c][5] mod 2 = 0 then
									begin
										write('normal position; ');
										if printfile then
											write(fingeringfile, 'normal position; ')
									end;
								if r[c][5] mod 3 = 0 then
									begin
										write('two fingers in same halfpos; ');
										if printfile then
											write(fingeringfile, 'two fingers in same halfpos; ')
									end;
								if r[c][5] mod 4 = 0 then
									begin
										write('open string may be hindered; ');
										if printfile then
											write(fingeringfile, 'open string may be hindered; ')
									end;
								if r[c][5] mod 5 = 0 then
									begin
										write('twice stretched; ');
										if printfile then
											write(fingeringfile, 'twice stretched; ')
									end;
								if r[c][5] mod 7 = 0 then
									begin
										write('very wide stretching; ');
										if printfile then
											write(fingeringfile, 'very wide stretching; ')
									end;
								if r[c][5] mod 11 = 0 then
									begin
										write('barre chord; ');
										if printfile then
											write(fingeringfile, 'barre chord; ')
									end;
								if r[c][5] mod 13 = 0 then
									begin
										write('Q-position; ');
										if printfile then
											write(fingeringfile, 'Q-position; ')
									end
							end
					end;
				c := c + 1
			until arrempty or (c = number + 1)
		end;

		function feasible (fi: lefthand): boolean;
		begin{feasible}
			feasible := TRUE;
			if (strinstrnt = vln) or (strinstrnt = vla) then
				begin
					if fi[1] = fi[2] then
						if not (fi[1] = 99) then
							feasible := FALSE;
					if fi[2] = fi[3] then
						if not (fi[2] = 99) then
							feasible := FALSE;
					if fi[3] = fi[4] then
						if not (fi[3] = 99) then
							feasible := FALSE;
					if (incr2 + incr3 + incr4 > 7) and (halfposition < 5) then
						feasible := FALSE;
					if incr2 + incr3 + incr4 > 8 then
						feasible := FALSE
				end;
			if strinstrnt = vlc then
				case halfposition of
					1..3: 
						if incr2 + incr3 + incr4 > 5 then
							feasible := FALSE;
					4..6: 
						if incr2 + incr3 + incr4 > 6 then
							feasible := FALSE;
					7, 8: 
						if incr2 + incr3 + incr4 > 7 then
							feasible := FALSE;
					otherwise
						if incr2 + incr3 + incr4 > 8 then
							feasible := FALSE;
				end;
		end;{feasible}

	begin{givefingeringsfor}
		taskdone := FALSE;
		counter := 0;
{----------initialize array to zero-------------}
		for a := 1 to number do
			for str := 1 to 5 do
				inventory[a][str] := 99;
{----------specify the tuning------------------}
		case strinstrnt of
			vln: 
				begin
					tuning[1] := 76;
					tuning[2] := 69;
					tuning[3] := 62;
					tuning[4] := 55;
					i := 0;
					ii := i;
					ij := 4;
					j := 4
				end;
			vla: 
				begin
					tuning[1] := 69;
					tuning[2] := 62;
					tuning[3] := 55;
					tuning[4] := 48;
					i := 0;
					ii := i;
					ij := 4;
					j := 3
				end;
			vlc: 
				begin
					tuning[1] := 57;
					tuning[2] := 40;
					tuning[3] := 43;
					tuning[4] := 36;
					i := 1
				end
		end;
{-----see whether the chord can be done without any left hand at all...------}
		tuningset := [];
		for a := 1 to 4 do
			tuningset := tuningset + [tuning[a]];
		if target <= tuningset then
			begin
				nolefthand := TRUE;
				a := tuning[4] - 1;
				b := 0;
				repeat
					repeat
						a := a + 1
					until (a in target) or (a > tuning[1]);
					if a in target then
						begin
							if (b > 0) and (a - b <> 7) then
								nolefthand := FALSE;
							b := a
						end
				until a > tuning[1];
				if nolefthand then
					begin {zzzzzz}
						for str := 1 to 4 do
							if tuning[str] in target then
								inventory[1][str] := 0;
						inventory[1][5] := 0
					end
			end;
{-------------work your way through all relevant positions---------------}
		giveprelposfor(target, pset);
		for halfposition := 1 to 17 do
			if halfposition in pset then
				begin
					writeln;
					write('Halfposition ', halfposition : 2, ' ');
					if strinstrnt = vlc then
						case halfposition of
							1..3: 
								begin
									ii := 0;
									ij := 3;
									j := 2
								end;
							4..6: 
								begin
									ii := 0;
									ij := 4;
									j := 2
								end;
							7, 8: 
								begin
									ii := 0;
									ij := 4;
									j := 2
								end;
							otherwise
								begin
									ii := 0;
									ij := 5;
									j := 2
								end;
						end;
{----------through all distance relations between fingers------------}
					for incr2 := i to ij do
						for incr3 := ii to j do
							for incr4 := ii to j do
{----------through all distributions of fingers over strings---------}
								for f1 := 1 to 4 do
									for f2 := 1 to 4 do
										if f2 <> f1 then
											for f3 := 1 to 4 do
												if (f3 <> f2) and (f3 <> f1) then
													for f4 := 1 to 4 do
														if ((f4 <> f3) and (f4 <> f2)) and (f4 <> f1) then
															begin
																fingering[f1] := halfposition;
																fingering[f2] := fingering[f1] + incr2;
																fingering[f3] := fingering[f2] + incr3;
																fingering[f4] := fingering[f3] + incr4;
																if not taskdone then
																	if feasible(fingering) then
																		begin
																			for str := 1 to 4 do
																				if str in exceptstrings then
																					fingering[str] := 99;
																			if counter >= 32 then
																				begin
																					write('.');
																					counter := 0
																				end;
																			counter := counter + 1;
																			alerts := 1;
																			fiftheds := [];
																			report(fingering);
																			dozeroson := dozeroson - exceptstrings;
																			openstrings(fingering, dozeroson);
																			if dofifths then
																				lessfingers(fingering);
																			if strinstrnt = vlc then
																				if ((halfposition < 12) and (incr2 < 3)) and ((incr3 = 1) and (incr4 = 1)) then
																					if (f1 >= 3) or (f2 >= 3) then
																						barrechords(fingering)
																		end;
															end
				end;
		writeresults(inventory)
	end;{givefingeringsfor}

begin{main}
	SetRect(fullScreen, 9, 44, 502, 336);
	SetTextRect(fullScreen);
	ShowText;
	alldone := FALSE;
	printfile := FALSE;
	repeat
		if not printfile then
			decidewhethertoprint;
		specifytask(target, ins);
		givefingeringsfor(ins);
		writeln;
		write('Done? Y/N-->');
		readln(ch);
		if upcased(ch) = 'N' then
			alldone := FALSE
		else
			alldone := TRUE
	until alldone;
	if printfile then
		close(fingeringfile)
end.{main}